## hypre 2.29.0

=== src/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

cmake_minimum_required(VERSION 3.13...3.16)

if (${CMAKE_VERSION} VERSION_LESS 3.16)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else ()
  cmake_policy(VERSION 3.16)
endif ()

# The version number.
set(HYPRE_VERSION 2.29.0)
set(HYPRE_NUMBER  22900)
set(HYPRE_DATE    2023/06/22)
set(HYPRE_TIME    00:00:00)
set(HYPRE_BUGS    https://github.com/hypre-space/hypre/issues)
set(HYPRE_SRCDIR  "${PROJECT_SOURCE_DIR}")

set(PROJECT_NAME HYPRE)
project(${PROJECT_NAME}
  VERSION ${HYPRE_VERSION}
  LANGUAGES C)

if (${HYPRE_SOURCE_DIR} STREQUAL ${HYPRE_BINARY_DIR})
  message(FATAL_ERROR "In-place build not allowed! Please use a separate build directory. See the Users Manual or INSTALL file for details.")
endif ()

if (EXISTS ${HYPRE_SOURCE_DIR}/../.git)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} describe --match v* --long --abbrev=9
                  OUTPUT_VARIABLE develop_string
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} describe --match v* --abbrev=0
                  OUTPUT_VARIABLE develop_lastag
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} rev-list --count ${develop_lastag}..HEAD
                  OUTPUT_VARIABLE develop_number
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} rev-parse --abbrev-ref HEAD
                  OUTPUT_VARIABLE develop_branch
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (${develop_string} MATCHES ".*")
    set(HYPRE_DEVELOP_STRING  ${develop_string})
    set(HYPRE_DEVELOP_NUMBER  ${develop_number})
    set(HYPRE_BRANCH_NAME     ${develop_branch})
    if (develop_branch MATCHES "master")
      set(HYPRE_DEVELOP_BRANCH  ${develop_branch})
    else ()
      message(STATUS "NOTE: On branch ${develop_branch}, not the main development branch")
    endif ()
  else ()
    message(STATUS "NOTE: Could not describe development branch")
  endif ()
else ()
  message(STATUS "NOTE: Could not find .git directory")
endif ()

# Set cmake module path
set(CMAKE_MODULE_PATH "${HYPRE_SOURCE_DIR}/config/cmake" "${CMAKE_MODULE_PATH}")
include(HYPRE_CMakeUtilities)

# Set default installation directory, but provide a means for users to change
set(HYPRE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/hypre" CACHE PATH
    "Installation directory for HYPRE")
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "${HYPRE_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)
endif ()

# Set default compile optimization flag
set(HYPRE_BUILD_TYPE "Release" CACHE STRING
    "Optimization flags: set to Debug, Release, RelWithDebInfo, or MinSizeRel")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "${HYPRE_BUILD_TYPE}" CACHE INTERNAL "" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif ()

# Configuration options
option(HYPRE_ENABLE_SHARED           "Build a shared library" OFF)
option(HYPRE_ENABLE_BIGINT           "Use long long int for HYPRE_Int" OFF)
option(HYPRE_ENABLE_MIXEDINT         "Use long long int for HYPRE_BigInt, int for HYPRE_INT" OFF)
option(HYPRE_ENABLE_SINGLE           "Use float for HYPRE_Real" OFF)
option(HYPRE_ENABLE_LONG_DOUBLE      "Use long double for HYPRE_Real" OFF)
option(HYPRE_ENABLE_COMPLEX          "Use complex values" OFF)
option(HYPRE_ENABLE_HYPRE_BLAS       "Use internal BLAS library" ON)
option(HYPRE_ENABLE_HYPRE_LAPACK     "Use internal LAPACK library" ON)
option(HYPRE_ENABLE_PERSISTENT_COMM  "Use persistent communication" OFF)
option(HYPRE_ENABLE_FEI              "Use FEI" OFF) # TODO: Add this cmake feature
option(HYPRE_WITH_MPI                "Compile with MPI" ON)
option(HYPRE_WITH_GPU_AWARE_MPI      "Compile with device aware GPU support" OFF)
option(HYPRE_WITH_OPENMP             "Use OpenMP" OFF)
option(HYPRE_ENABLE_HOPSCOTCH        "Use hopscotch hashing with OpenMP" OFF)
option(HYPRE_WITH_SUPERLU            "Use TPL SuperLU" OFF)
option(HYPRE_WITH_DSUPERLU           "Use TPL SuperLU_Dist" OFF)
option(HYPRE_WITH_MAGMA              "Use TPL MAGMA" OFF)
option(HYPRE_WITH_CALIPER            "Use Caliper" OFF)
option(HYPRE_PRINT_ERRORS            "Print HYPRE errors" OFF)
option(HYPRE_TIMING                  "Use HYPRE timing routines" OFF)
option(HYPRE_BUILD_EXAMPLES          "Build examples" OFF)
option(HYPRE_BUILD_TESTS             "Build tests" OFF)
option(HYPRE_USING_HOST_MEMORY       "Use host memory" ON)
set(HYPRE_WITH_EXTRA_CFLAGS       "" CACHE STRING "Define extra C compile flags")
set(HYPRE_WITH_EXTRA_CXXFLAGS     "" CACHE STRING "Define extra CXX compile flags")
# GPU options
option(HYPRE_WITH_CUDA               "Use CUDA. Require cuda-8.0 or higher" OFF)
option(HYPRE_WITH_SYCL               "Use SYCL" OFF)
option(HYPRE_ENABLE_UNIFIED_MEMORY   "Use unified memory for allocating the memory" OFF)
option(HYPRE_ENABLE_DEVICE_MALLOC_ASYNC "Use device async malloc" OFF)
# CUDA options
option(HYPRE_ENABLE_CUDA_STREAMS     "Use CUDA streams" ON)
option(HYPRE_ENABLE_CUSPARSE         "Use cuSPARSE" ON)
option(HYPRE_ENABLE_CUSOLVER         "Use cuSOLVER" OFF)
option(HYPRE_ENABLE_DEVICE_POOL      "Use device memory pool" OFF)
option(HYPRE_ENABLE_CUBLAS           "Use cuBLAS" OFF)
option(HYPRE_ENABLE_CURAND           "Use cuRAND" ON)
option(HYPRE_ENABLE_GPU_PROFILING    "Use NVTX on CUDA" OFF)
set(HYPRE_CUDA_SM "70" CACHE STRING  "Target CUDA architecture.")
# oneAPI options
option(HYPRE_ENABLE_ONEMKLSPARSE     "Use oneMKL sparse" ON)
option(HYPRE_ENABLE_ONEMKLBLAS       "Use oneMKL blas" ON)
option(HYPRE_ENABLE_ONEMKLRAND       "Use oneMKL rand" ON)
set(HYPRE_SYCL_TARGET            ""   CACHE STRING  "Target SYCL architecture, e.g. 'spir64_gen'.")
set(HYPRE_SYCL_TARGET_BACKEND    ""   CACHE STRING  "Additional SYCL backend options, e.g. '-device 12.1.0,12.4.0'.")
# Umpire resource management options
option(HYPRE_WITH_UMPIRE             "Use Umpire Allocator for device and unified memory" OFF)
option(HYPRE_WITH_UMPIRE_HOST        "Use Umpire Allocator for host memory" OFF)
option(HYPRE_WITH_UMPIRE_DEVICE      "Use Umpire Allocator for device memory" OFF)
option(HYPRE_WITH_UMPIRE_UM          "Use Umpire Allocator for unified memory" OFF)
option(HYPRE_WITH_UMPIRE_PINNED      "Use Umpire Allocator for pinned memory" OFF)
option(TPL_UMPIRE_LIBRARIES          "List of absolute paths to Umpire link libraries [].")
option(TPL_UMPIRE_INCLUDE_DIRS       "List of absolute paths to Umpire include directories [].")

option(TPL_SUPERLU_LIBRARIES         "List of absolute paths to SuperLU link libraries [].")
option(TPL_SUPERLU_INCLUDE_DIRS      "List of absolute paths to SuperLU include directories [].")
option(TPL_DSUPERLU_LIBRARIES        "List of absolute paths to SuperLU_Dist link libraries [].")
option(TPL_DSUPERLU_INCLUDE_DIRS     "List of absolute paths to SuperLU_Dist include directories [].")
option(TPL_MAGMA_LIBRARIES           "List of absolute paths to MAGMA link libraries [].")
option(TPL_MAGMA_INCLUDE_DIRS        "List of absolute paths to MAGMA include directories [].")
option(TPL_BLAS_LIBRARIES            "Optional list of absolute paths to BLAS libraries, otherwise use FindBLAS to locate [].")
option(TPL_LAPACK_LIBRARIES          "Optional list of absolute paths to LAPACK libraries, otherwise use FindLAPACK to locate [].")
option(TPL_FEI_INCLUDE_DIRS          "List of absolute paths to FEI include directories [].")

# Set config name values
if (HYPRE_ENABLE_SHARED)
  set(HYPRE_SHARED ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_BIGINT)
  set(HYPRE_BIGINT ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_MIXEDINT)
  set(HYPRE_MIXEDINT ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_SINGLE)
  set(HYPRE_SINGLE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_LONG_DOUBLE)
  set(HYPRE_LONG_DOUBLE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_COMPLEX)
  set(HYPRE_COMPLEX ON CACHE BOOL "" FORCE)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(HYPRE_DEBUG ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HYPRE_BLAS)
  set(HYPRE_USING_HYPRE_BLAS ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HYPRE_LAPACK)
  set(HYPRE_USING_HYPRE_LAPACK ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_PERSISTENT_COMM)
  set(HYPRE_USING_PERSISTENT_COMM ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_MPI)
  set(HYPRE_HAVE_MPI ON CACHE BOOL "" FORCE)
  set(HYPRE_SEQUENTIAL OFF CACHE BOOL "" FORCE)
else ()
  set(HYPRE_SEQUENTIAL ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_OPENMP)
  set(HYPRE_USING_OPENMP ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HOPSCOTCH)
  set(HYPRE_HOPSCOTCH ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_SUPERLU)
  set(HYPRE_USING_SUPERLU ON CACHE BOOL "" FORCE)
  add_compile_definitions(HAVE_SUPERLU)
endif ()

if (HYPRE_WITH_DSUPERLU)
  set(HYPRE_USING_DSUPERLU ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_HYPRE_BLAS OFF CACHE BOOL "" FORCE)
  set(HYPRE_USING_HYPRE_LAPACK OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_MAGMA)
  set(HYPRE_USING_MAGMA ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_FEI)
  set(HYPRE_USING_FEI ON CACHE BOOL "" FORCE)
  message(WARNING "CMake support for FEI is not complete!")
endif ()

if (HYPRE_WITH_CALIPER)
  set(HYPRE_USING_CALIPER ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SHARED OR HYPRE_BIGINT OR HYPRE_SINGLE OR HYPRE_LONG_DOUBLE)
  # FEI doesn't currently compile with shared
  set(HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SEQUENTIAL)
  set(HYPRE_BUILD_EXAMPLES OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_DEVICE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_UM ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_HOST)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_HOST ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_DEVICE)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_DEVICE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_UM)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_UM ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_PINNED)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_PINNED ON CACHE BOOL "" FORCE)
endif ()

# CUDA
if (HYPRE_WITH_CUDA)
  enable_language(CXX)
  message(STATUS "Enabled support for CXX.")

  # Enforce C++11
  if (NOT CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD LESS 11)
    set(CMAKE_CXX_STANDARD 11)
  endif ()
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  message(STATUS "Using CXX standard: c++${CMAKE_CXX_STANDARD}")

  # Add any extra CXX compiler flags HYPRE_WITH_EXTRA_CXXFLAGS
  if (NOT HYPRE_WITH_EXTRA_CXXFLAGS STREQUAL "")
    string(REPLACE " " ";" HYPRE_WITH_EXTRA_CXXFLAGS "${HYPRE_WITH_EXTRA_CXXFLAGS}")
    add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:${HYPRE_WITH_EXTRA_CXXFLAGS}>")
  endif ()

  # Check if CUDA is available, then enable it
  include(CheckLanguage)
  check_language(CUDA)

  # Use ${CMAKE_CXX_COMPILER} as the cuda host compiler.
  if (NOT CMAKE_CUDA_HOST_COMPILER)
    set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})
  endif ()

  if (CMAKE_CUDA_COMPILER)

    enable_language(CUDA)
    message(STATUS "Enabled support for CUDA.")

    if (NOT CMAKE_CUDA_STANDARD OR CMAKE_CUDA_STANDARD EQUAL 98)
      set(CMAKE_CUDA_STANDARD 11)
    endif ()

    set(CMAKE_CUDA_STANDARD_REQUIRED ON CACHE BOOL "" FORCE)

    if (HYPRE_ENABLE_DEVICE_MALLOC_ASYNC)
      set(HYPRE_USING_DEVICE_MALLOC_ASYNC ON CACHE BOOL "" FORCE)
    endif ()

    set(HYPRE_USING_CUDA ON CACHE BOOL "" FORCE)

=== src/parcsr_ls/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  HYPRE_parcsr_ls.h
  _hypre_parcsr_ls.h
)

set(SRCS
  amg_hybrid.c
  aux_interp.c
  F90_hypre_laplace.c
  F90_HYPRE_parcsr_amg.c
  F90_HYPRE_parcsr_bicgstab.c
  F90_HYPRE_parcsr_block.c
  F90_HYPRE_parcsr_cgnr.c
  F90_HYPRE_parcsr_Euclid.c
  F90_HYPRE_parcsr_gmres.c
  F90_HYPRE_parcsr_cogmres.c
  F90_HYPRE_parcsr_flexgmres.c
  F90_HYPRE_parcsr_lgmres.c
  F90_HYPRE_parcsr_hybrid.c
  F90_HYPRE_parcsr_int.c
  F90_HYPRE_parcsr_ParaSails.c
  F90_HYPRE_parcsr_pcg.c
  F90_HYPRE_parcsr_pilut.c
  F90_HYPRE_parcsr_schwarz.c
  F90_HYPRE_ams.c
  gen_redcs_mat.c
  HYPRE_parcsr_amg.c
  HYPRE_parcsr_amgdd.c
  HYPRE_parcsr_bicgstab.c
  HYPRE_parcsr_block.c
  HYPRE_parcsr_cgnr.c
  HYPRE_parcsr_Euclid.c
  HYPRE_parcsr_gmres.c
  HYPRE_parcsr_cogmres.c
  HYPRE_parcsr_flexgmres.c
  HYPRE_parcsr_lgmres.c
  HYPRE_parcsr_hybrid.c
  HYPRE_parcsr_int.c
  HYPRE_parcsr_ilu.c
  HYPRE_parcsr_mgr.c
  HYPRE_parcsr_ParaSails.c
  HYPRE_parcsr_pcg.c
  HYPRE_parcsr_pilut.c
  HYPRE_parcsr_schwarz.c
  HYPRE_parcsr_fsai.c
  HYPRE_ams.c
  HYPRE_ads.c
  HYPRE_ame.c
  par_2s_interp.c
  par_amg.c
  par_amgdd.c
  par_amgdd_comp_grid.c
  par_amgdd_solve.c
  par_amgdd_helpers.c
  par_amgdd_fac_cycle.c
  par_amgdd_setup.c
  par_amg_setup.c
  par_amg_solve.c
  par_amg_solveT.c
  par_cg_relax_wt.c
  par_coarsen.c
  par_cgc_coarsen.c
  par_cheby.c
  par_cheby_device.c
  par_coarse_parms.c
  par_coarse_parms_device.c
  par_coordinates.c
  par_cr.c
  par_cycle.c
  par_add_cycle.c
  par_difconv.c
  par_fsai.c
  par_fsai_setup.c
  par_fsai_solve.c
  par_gauss_elim.c
  par_gsmg.c
  par_indepset.c
  par_interp.c
  par_jacobi_interp.c
  par_krylov_func.c
  par_mod_lr_interp.c
  par_mod_multi_interp.c
  par_multi_interp.c
  par_laplace_27pt.c
  par_laplace_9pt.c
  par_laplace.c
  par_lr_interp.c
  par_mgr.c
  par_mgr_coarsen.c
  par_mgr_setup.c
  par_mgr_solve.c
  par_nongalerkin.c
  par_nodal_systems.c
  par_rap.c
  par_rap_communication.c
  par_rotate_7pt.c
  par_vardifconv.c
  par_vardifconv_rs.c
  par_relax.c
  par_relax_more.c
  par_relax_more_device.c
  par_relax_interface.c
  par_scaled_matnorm.c
  par_schwarz.c
  par_stats.c
  par_strength.c
  par_sv_interp.c
  par_sv_interp_ln.c
  partial.c
  schwarz.c
  block_tridiag.c
  ams.c
  ads.c
  ame.c
  par_restr.c
  par_lr_restr.c
  par_mgr.c
  par_mgr_setup.c
  par_mgr_solve.c
  par_ilu.c
  par_ilu_setup.c
  par_ilu_setup_device.c
  par_ilu_solve.c
  par_ilu_solve_device.c
  par_coarsen_device.c
  par_indepset_device.c
  par_interp_device.c
  par_interp_trunc_device.c
  par_lr_interp_device.c
  par_lr_restr_device.c
  par_strength_device.c
  par_strength2nd_device.c
  par_amgdd_fac_cycle_device.c
  par_2s_interp_device.c
  par_relax_device.c
  par_mod_multi_interp_device.c
  par_mgr_device.c
)

if (HYPRE_USING_DSUPERLU)
  list(APPEND SRCS dsuperlu.c)
endif()

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA OR HYPRE_USING_SYCL)
  set(GPU_SRCS
    ams.c
    ads.c
    ame.c
    par_amg_setup.c
    par_ilu.c
    par_ilu_setup.c
    par_ilu_setup_device.c
    par_ilu_solve.c
    par_ilu_solve_device.c
    par_coarsen_device.c
    par_coarse_parms_device.c
    par_indepset_device.c
    par_interp_device.c
    par_interp_trunc_device.c
    par_lr_interp_device.c
    par_lr_restr_device.c
    par_mod_multi_interp_device.c
    par_strength_device.c
    par_strength2nd_device.c
    par_relax_more_device.c
    par_cheby_device.c
    par_amgdd_fac_cycle_device.c
    par_2s_interp_device.c
    par_relax_device.c
    par_mgr_device.c
  )
  convert_filenames_to_full_paths(GPU_SRCS)
  set(HYPRE_GPU_SOURCES ${HYPRE_GPU_SOURCES} ${GPU_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/parcsr_ls/Makefile ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

## Euclid specific macros taken from distributed_ls/Euclid

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I../distributed_ls/Euclid\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../blas\
 -I$(srcdir)/../lapack\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../krylov\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../distributed_matrix\
 -I$(srcdir)/../matrix_matrix\
 -I$(srcdir)/../IJ_mv\
 -I$(srcdir)/../parcsr_block_mv\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}

HEADERS =\
 HYPRE_parcsr_ls.h\
 _hypre_parcsr_ls.h\
 aux_interp.h\
 block_tridiag.h\
 Common.h\
 par_amg.h\
 par_amgdd.h\
 par_amgdd_comp_grid.h\
 par_fsai.h\
 schwarz.h

FILES =\
 amg_hybrid.c\
 aux_interp.c\
 F90_hypre_laplace.c\
 F90_HYPRE_parcsr_amg.c\
 F90_HYPRE_parcsr_bicgstab.c\
 F90_HYPRE_parcsr_block.c\
 F90_HYPRE_parcsr_cgnr.c\
 F90_HYPRE_parcsr_Euclid.c\
 F90_HYPRE_parcsr_gmres.c\
 F90_HYPRE_parcsr_cogmres.c\
 F90_HYPRE_parcsr_flexgmres.c\
 F90_HYPRE_parcsr_lgmres.c\
 F90_HYPRE_parcsr_hybrid.c\
 F90_HYPRE_parcsr_int.c\
 F90_HYPRE_parcsr_ParaSails.c\
 F90_HYPRE_parcsr_pcg.c\
 F90_HYPRE_parcsr_pilut.c\
 F90_HYPRE_parcsr_schwarz.c\
 F90_HYPRE_parcsr_mgr.c\
 F90_HYPRE_parcsr_ilu.c\
 F90_HYPRE_ams.c\
 gen_redcs_mat.c\
 HYPRE_parcsr_amg.c\
 HYPRE_parcsr_amgdd.c\
 HYPRE_parcsr_bicgstab.c\
 HYPRE_parcsr_block.c\
 HYPRE_parcsr_cgnr.c\
 HYPRE_parcsr_Euclid.c\
 HYPRE_parcsr_gmres.c\
 HYPRE_parcsr_cogmres.c\
 HYPRE_parcsr_flexgmres.c\
 HYPRE_parcsr_lgmres.c\
 HYPRE_parcsr_hybrid.c\
 HYPRE_parcsr_int.c\
 HYPRE_parcsr_mgr.c\
 HYPRE_parcsr_ilu.c \
 HYPRE_parcsr_fsai.c \
 HYPRE_parcsr_ParaSails.c\
 HYPRE_parcsr_pcg.c\
 HYPRE_parcsr_pilut.c\
 HYPRE_parcsr_schwarz.c\
 HYPRE_ams.c\
 HYPRE_ads.c\
 HYPRE_ame.c\
 par_2s_interp.c\
 par_amg.c\
 par_amgdd.c\
 par_amgdd_comp_grid.c\
 par_amgdd_setup.c\
 par_amgdd_solve.c\
 par_amgdd_fac_cycle.c\
 par_amgdd_helpers.c\
 par_amg_solve.c\
 par_amg_solveT.c\
 par_fsai.c\
 par_fsai_setup.c\
 par_fsai_solve.c\
 par_cg_relax_wt.c\
 par_coarsen.c\
 par_cgc_coarsen.c\
 par_cheby.c\
 par_coarse_parms.c\
 par_coordinates.c\
 par_cr.c\
 par_cycle.c\
 par_add_cycle.c\
 par_difconv.c\
 par_gauss_elim.c\
 par_gsmg.c\
 par_indepset.c\
 par_interp.c\
 par_jacobi_interp.c\
 par_krylov_func.c\
 par_ilu.c\
 par_ilu_setup.c \
 par_mod_lr_interp.c\
 par_multi_interp.c\
 par_mod_multi_interp.c\
 par_laplace.c\
 par_laplace_27pt.c\
 par_laplace_9pt.c\
 par_lr_interp.c\
 par_mgr.c\
 par_mgr_coarsen.c\
 par_mgr_setup.c\
 par_mgr_solve.c\
 par_nongalerkin.c\
 par_nodal_systems.c\
 par_rap.c\
 par_rap_communication.c\
 par_rotate_7pt.c\
 par_relax.c\
 par_relax_more.c\
 par_relax_interface.c\
 par_scaled_matnorm.c\
 par_schwarz.c\
 par_stats.c\
 par_strength.c\
 par_sv_interp.c\
 par_sv_interp_ln.c\
 par_vardifconv.c\
 par_vardifconv_rs.c\
 partial.c\
 schwarz.c\
 block_tridiag.c\
 par_restr.c\
 par_lr_restr.c\
 dsuperlu.c

CUFILES =\
 ads.c\
 ams.c\
 ame.c\
 par_amg_setup.c\
 par_ilu_setup_device.c\
 par_ilu_solve_device.c\
 par_ilu_solve.c \
 par_cheby_device.c\
 par_relax_more_device.c\
 par_coarsen_device.c\
 par_coarse_parms_device.c\
 par_indepset_device.c\
 par_interp_device.c\
 par_lr_restr_device.c\
 par_interp_trunc_device.c\
 par_lr_interp_device.c\
 par_strength_device.c\
 par_strength2nd_device.c\
 par_amgdd_fac_cycle_device.c\
 par_2s_interp_device.c\
 par_relax_device.c\
 par_mod_multi_interp_device.c\
 par_mgr_device.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_parcsr_ls-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean


##################################################################
# Rules
##################################################################

libHYPRE_parcsr_ls.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_parcsr_ls.so libHYPRE_parcsr_ls.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s -f ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/utilities/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  HYPRE_utilities.h
  _hypre_utilities.h
  _hypre_utilities.hpp
  HYPRE_error_f.h
  fortran.h
  fortran_matrix.h
)

set(SRCS
  HYPRE_handle.c
  HYPRE_version.c
  amg_linklist.c
  binsearch.c
  exchange_data.c
  F90_HYPRE_error.c
  F90_HYPRE_general.c
  fortran_matrix.c
  ap.c
  log.c
  complex.c
  device_utils.c
  error.c
  general.c
  handle.c
  int_array.c
  int_array_device.c
  hopscotch_hash.c
  magma.c
  memory.c
  memory_tracker.c
  merge_sort.c
  mmio.c
  mpi_comm_f2c.c
  nvtx.c
  omp_device.c
  prefix_sum.c
  printf.c
  qsort.c
  utilities.c
  mpistubs.c
  qsplit.c
  random.c
  state.c
  threading.c
  timer.c
  timing.c
)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA OR HYPRE_USING_SYCL)
  set(GPU_SRCS
    device_utils.c
    general.c
    handle.c
    int_array_device.c
    memory.c
    memory_tracker.c
    nvtx.c
    omp_device.c
    HYPRE_handle.c
  )
  convert_filenames_to_full_paths(GPU_SRCS)
  set(HYPRE_GPU_SOURCES ${HYPRE_GPU_SOURCES} ${GPU_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/utilities/Makefile ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}
CDEFS = ${TIMERDEFS}

C_COMPILE_FLAGS =\
   -I..\
   -I$(srcdir)/..\
   -I$(srcdir)/../struct_mv\
   -I$(srcdir)\
   ${CINCLUDES}\
   ${CDEFS}

CXX_COMPILE_FLAGS = ${C_COMPILE_FLAGS}

HEADERS =\
 amg_linklist.h\
 exchange_data.h\
 fortran.h\
 fortran_matrix.h\
 general.h\
 int_array.h\
 memory.h\
 memory_tracker.h\
 HYPRE_utilities.h\
 mpistubs.h\
 threading.h\
 timing.h\
 magma.h\
 _hypre_onedpl.hpp\
 _hypre_utilities.h\
 _hypre_utilities.hpp

FILES =\
 F90_HYPRE_error.c\
 F90_HYPRE_general.c\
 HYPRE_handle.c\
 HYPRE_version.c\
 amg_linklist.c\
 binsearch.c\
 exchange_data.c\
 fortran_matrix.c\
 ap.c\
 log.c\
 complex.c\
 error.c\
 int_array.c\
 hopscotch_hash.c\
 magma.c\
 memory_tracker.c\
 merge_sort.c\
 mmio.c\
 mpi_comm_f2c.c\
 prefix_sum.c\
 printf.c\
 qsort.c\
 utilities.c\
 mpistubs.c\
 qsplit.c\
 random.c\
 state.c\
 threading.c\
 timer.c\
 timing.c

CUFILES=\
 device_utils.c\
 general.c\
 handle.c\
 int_array_device.c\
 memory.c\
 omp_device.c\
 nvtx.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_utilities-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_utilities${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_onedpl.hpp $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_utilities.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_utilities.hpp $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/fortran*.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_utilities${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_utilities.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/fortran*.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_utilities.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_utilities.so libHYPRE_utilities.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s -f ${SONAME} $@

${OBJS}: ${HEADERS}

=== debian/changelog ===
hypre (2.29.0-2) unstable; urgency=medium

  * Team upload.
  * Build-Depends: pkgconf not pkg-config
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 May 2024 15:02:30 +0200

hypre (2.29.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release
    - new ABI 2.29.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 29 Jun 2023 16:32:53 +0200

hypre (2.28.0-8) unstable; urgency=medium

  * Team upload.
  * debian/rules: add loong64 to list of arches needing a relaxed
    test tolerance for build-time tests. Closes: #1058461.
  * after dh_clean remove src*-static copies of the src dir.
    Closes: #1046864

 -- Drew Parsons <dparsons@debian.org>  Mon, 18 Dec 2023 17:01:24 +0100

hypre (2.28.0-7) unstable; urgency=medium

  * Team upload.
  * run build-time tests (make check) on ppc64el, only skip checkpar.
    Likewise with hurd-i386.
  * relax checkpar tolerance on riscv64. Closes: #1050225
  * report number of available processors (nproc) when running tests
    (hanging tests is more likely when oversubscribing)

 -- Drew Parsons <dparsons@debian.org>  Tue, 29 Aug 2023 10:26:33 +0200

hypre (2.28.0-6) unstable; urgency=medium

  * Team upload.
  * skip build tests on ppc64el, which consistently times out
    (possibly due to pmix mishandling MPI finalisation,
    see upstream Issue #955)
  * skip build tests on ia64, which fails to build the tests

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Aug 2023 11:33:24 +0200

hypre (2.28.0-5) unstable; urgency=medium

  * Team upload.
  * update debian patch fix_make_check.patch to allow checkpar
    tolerance to be relaxed. Relax tolerance to 1e-3, only on
    arches which didn't meet the default tolerance 1e-6:
    arm64 i386 ppc64el s390x hppa powerpc ppc64
    Handled via new makefile variable HYPRE_CHECKPAR_TOL.

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Aug 2023 16:48:26 +0200

hypre (2.28.0-4) unstable; urgency=medium

  * Team upload.
  * debian patch fix_make_check.patch: print contents of error file if
    failure detected in checktest.sh.

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Aug 2023 11:43:51 +0200

hypre (2.28.0-3) unstable; urgency=medium

  * Team upload.
  * hypre tests have been generally flaky, occasionally timing out
    (and always timing out on ppc64el, armel, ia64). Following upstream
    advice (Issue#955), run tests via `make check`, `make checkpar`,
    which runs a more controlled subset of all available tests.
    - reinstate build-time tests on armel, ia64
  * debian/tests: use make check same as build-time tests
    but do not run checkpar (takes a different number of iterations
    which as treated as an error)
    - reinstate debian CI tests on armhf
  * debian patch fix_make_check.patch fixes the `make check` rules
    - use set -e to not ignore test failures
    - checkpar uses -atol not -tol
    - return error code from checktest.sh

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Aug 2023 02:49:37 +0200

=== debian/control ===
Source: hypre
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 4.7.0
Build-Depends:
 autoconf,
 automake,
 debhelper-compat (= 13),
 pkgconf,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas-base-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libblas64.so [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32],
 liblapack64-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas-base-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | liblapack64.so [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32],
 libsuperlu-dev, libsuperlu-dist-dev (>= 6.3),
 libltdl-dev,
 libtool,
 mpi-default-dev,
Vcs-Git: https://salsa.debian.org/science-team/hypre.git
Vcs-Browser: https://salsa.debian.org/science-team/hypre
Homepage: https://www.llnl.gov/casc/hypre/

Package: libhypre-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre-2.29.0 (= ${binary:Version}),
 libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
 libopenblas-dev | libatlas-base-dev | liblapack-dev | liblapack.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre.

Package: libhypre-2.29.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library.

Package: libhypre64-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre64-2.29.0 (= ${binary:Version}),
 libopenblas64-dev | libblas64-dev | libblas64.so,
 libopenblas64-dev | liblapack64-dev | liblapack64.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (bigint) Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre with 64-bit integers for both HYPRE_BigInt
 and HYPRE_Int (--with-bigint).

Package: libhypre64-2.29.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (bigint) Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library supporting 64-bit integers
 for both HYPRE_BigInt and HYPRE_Int (--with-bigint).

Package: libhypre64m-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre64m-2.29.0 (= ${binary:Version}),
 libopenblas64-dev | libblas64-dev | libblas64.so,
 libopenblas64-dev | liblapack64-dev | liblapack64.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (mixedint) Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre with 64-bit HYPRE_BigInt and 32-bit HYPRE_Int
 (--with-mixedint).
 .
 Note that segfaults have been reported in MPI tests. libhypre64m
 (mixedint) might not be safe, and should be considered experimental.
 Use with care (or do not use). See
 https://github.com/hypre-space/hypre/issues/326



Package: libhypre64m-2.29.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (mixedint) Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library supporting 64-bit
 HYPRE_BigInt with 32-bit HYPRE_Int (--with-mixedint).
 .
 Note that segfaults have been reported in MPI tests. libhypre64m
 (mixedint) might not be safe, and should be considered experimental.
 Use with care (or do not use). See
 https://github.com/hypre-space/hypre/issues/326
